Subject: Re: [PATCH v2] net: stmmac: imx: Disable EEE

From: "Russell King (Oracle)" <[email-masked]>
Date: Tue, 10 Feb 2026 12:26:12 +0000

On Mon, Feb 09, 2026 at 10:21:55PM +0200, Laurent Pinchart wrote:
> The i.MX8MP suffers from an interrupt storm related to the stmmac and
> EEE. A long and tedious analysis ([1]) concluded that the SoC wires the
> stmmac lpi_intr_o signal to an OR gate along with the main dwmac
> interrupts, which causes an interrupt storm for two reasons.
> 
> First, there's a race condition due to the interrupt deassertion being
> synchronous to the RX clock domain:
> 
> - When the PHY exits LPI mode, it restarts generating the RX clock
>   (clk_rx_i input signal to the GMAC).
> - The MAC detects exit from LPI, and asserts lpi_intr_o. This triggers
>   the ENET_EQOS interrupt.
> - Before the CPU has time to process the interrupt, the PHY enters LPI
>   mode again, and stops generating the RX clock.
> - The CPU processes the interrupt and reads the GMAC4_LPI_CTRL_STATUS
>   registers. This does not clear lpi_intr_o as there's no clk_rx_i.
> 
> An attempt was made to fixing the issue by not stopping RX_CLK in Rx LPI
> state ([2]). This alleviates the symptoms but doesn't fix the issue.
> Since lpi_intr_o takes four RX_CLK cycles to clear, an interrupt storm
> can still occur during that window. In 1000T mode this is harder to
> notice, but slower receive clocks cause hundreds to thousands of
> spurious interrupts.
> 
> Fix the issue by disabling EEE completely on i.MX8MP.
> 
> [1] https://lore.kernel.org/all/[email-masked]/
> [2] https://lore.kernel.org/all/[email-masked]/
> 
> Signed-off-by: Laurent Pinchart <[email-masked]>
> ---
> This patch depends on https://lore.kernel.org/all/[email-masked]/

... and a few other patches as well. There is also a conflicting change
in net-next:

commit dc6597fab3e3d291da9e0b4c6f7da01a5a863e80
Author: Stefan Eichenberger <[email-masked]>
Date:   Tue Jan 20 21:30:04 2026 +0100

    net: stmmac: dwmac-imx: keep preamble before sfd on i.MX8MP

> base-commit: 05f7e89ab9731565d8a62e3b5d1ec206485eeb0b

This is v6.19

> prerequisite-patch-id: 9229185bf29c206923075a0450e763664af050bb
> prerequisite-patch-id: e17c3f8a7cb2b18fc0c3c6250773a9680bdabdba
> prerequisite-patch-id: a3c3f8b08fd66ee3ccce632aad3f4a3c21c92718

I have no idea what these are. These don't exist in Linus', net, nor
net-next trees. I'm not sure what generates these, but they are useless
unless they also indicate the summary line for the commit in question,
so that one can have some clue what change they're referring to.

While this is a fix, I think you previously suggested that this isn't
a regression, which suggests it should be merged in net-next (currently
closed due to the merge window) rather than net.

Also, referring to another patch doesn't get it applied - netdev
workflow uses patchwork, and patches to be applied need to be there.
If patches depend on each other, they need to be submitted as a
series. So either I need to pick up your patch and send it along
with mine, or you need to pick up my patch and send it with yours.
We need to come to agreement on who is submitting it.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 80Mbps down 10Mbps up. Decent connectivity at last!